<template>
  <el-row>
    <el-col :xs="12" :span="15" :lg="18">
        <el-input 
          @keyup.enter="toggleTask" 
          placeholder="Nom de votre tache"
          v-model="taskname" ></el-input>
    </el-col>
    <el-col :xs="12" :span="9" :lg="6" class="actions">
      <strong>{{ currentDuration }}</strong>
      <el-button v-if="!isTaskInProgress" @click="beforeStartTask" type="primary" icon="el-icon-video-play" circle aria-label="Start Task"></el-button>
      <el-button v-else @click="beforeStopTask" type="danger" icon="el-icon-video-pause" circle aria-label="Stop Task"></el-button>
    </el-col>
  </el-row>
</template>
<script>import { mapActions, mapState } from "vuex"

export default {
  computed: {
    ... mapState({
      isTaskInProgress: (state) => state.tasks.isTaskInProgress,    
      startTime: (state) => state.tasks.currentStartTime
    }),
    taskname: {
      get() {
        return this.$store.state.tasks.currentTaskname
      },
      set(value) {
        console.log(value);
        this.$store.commit('tasks/SET_CURRENT_TASKNAME', value)
      }
    },
    currentDuration () {
      if (this.startTime && this.nowTime) {
        return this.durationBetweenTimestamps(this.startTime, this.nowTime)
      } else {
        return '00:00:00'
      }
    }
  },
  watch: {
    isTaskInProgress (isInProgress) {
      if (isInProgress) {
        this.nowTime = Date.now()
        this.intervalEverySecond = setInterval(() => {
          this.nowTime = Date.now()
        }, 1000)
      } else {
        this.nowTime = null
        this.errorMsg = null
        clearInterval(this.intervalEverySecond)
      }
    },
    errorMsg(newVal) {
      if(newVal !== null) {
        this.warning({
          title: 'Attention',
          message: newVal
        })
        
        this.errorMsg = null
      }
    }
  },
  methods : {
    ... mapActions({
      stopTask: 'tasks/stopTask',
      startTask: 'tasks/startTask',
      warning: 'notifications/warning',
    }),
    beforeStartTask () {
      // Vérifications
      if (!this.taskname) {
        this.errorMsg = "Le nom d'une tâche ne peut pas être vide"
        return
      } else if (this.isTaskInProgress) {
        this.errorMsg = 'Une tâche est déjà en cours'
        return
      } else {
        this.errorMsg = null
      }

      this.startTask()
    },
    beforeStopTask () {
      // Vérifications
      if (!this.isTaskInProgress) {
        this.errorMsg = "Aucune tâche n'est en cours"
        return
      }

      this.stopTask()
    },
    toggleTask () {
      if (this.isTaskInProgress) {
        this.beforeStopTask()
      } else {
        this.beforeStartTask()
      }
    },
    durationBetweenTimestamps (start, end) {
      let seconds = Math.floor((end / 1000) - (start / 1000))
      let minutes = Math.floor(seconds / 60)
      const hours = Math.floor(minutes / 60)
      seconds = seconds % 60
      minutes = minutes % 60
      return `${String(hours).padStart(2, '0')}:${String(minutes).padStart(2, '0')}:${String(seconds).padStart(2, '0')}`
    }
  },
  data() {
    return {
      intervalEverySecond: null,
      errorMsg: null,
      nowTime: null
    }
  },
}
</script>

<style lang="scss" scoped>
  .el-input {
    margin-left: 20px;
    box-sizing: border-box;
    border: none;
  }
  .actions {
    text-align: right;
    padding-right: 20px;
    strong {
      padding-right: 20px;
    }
  }
</style>